-- the player
function PLAYER(xworld)
	-- some vars
	local minx, miny, minz -- can be negative
	local maxx, maxy, maxz
	local width, height, length -- obj dimensions
	-- the obj file
	local shipobj = loadObj("3d_objs/ship", "ship.obj")
	--LightingV1.apply(shipobj)
	minx, miny, minz = shipobj.min[1], shipobj.min[2], shipobj.min[3] -- can be negative numbers
	maxx, maxy, maxz = shipobj.max[1], shipobj.max[2], shipobj.max[3]
	local shipwidth, shipheight, shiplength = maxx - minx, maxy - miny, maxz - minz
	--print("shipobj", shipwidth, shipheight, shiplength)
	shipobj.shape1 = r3d.SphereShape.new(shipheight / 2) -- front
	shipobj.shape2 = r3d.BoxShape.new(shipwidth / 1, shipheight / 3, shiplength / 2) -- back (middle)
	shipobj.shape3 = r3d.SphereShape.new(shipheight / 2) -- right
	shipobj.shape4 = r3d.SphereShape.new(shipheight / 2) -- left
--	shipobj.shape = r3d.BoxShape.new(shipwidth / 2, shipheight / 2, shiplength / 2)
	shipobj.frontmass = 64
	shipobj.rearmass = 96
	local shipview = Viewport.new()
	shipview:setContent(shipobj)
	shipview:setPosition(0, shipheight * 6, 0) -- ship start position
	shipview.body = xworld:createBody(shipview:getMatrix())
	local m1, m2, m3, m4 = Matrix.new(), Matrix.new(), Matrix.new(), Matrix.new()
	m1:setPosition(0, 0, -shiplength / 2) -- front
	m2:setPosition(0, 0, shiplength * 1) -- back XXX
	m3:setPosition(-shipwidth / 2, 0, 0) -- right
	m4:setPosition(shipwidth / 2, 0, 0) -- left
	shipview.body:createFixture(shipobj.shape1, m1, shipobj.frontmass) -- shape, transform, mass
	shipview.body:createFixture(shipobj.shape2, m2, shipobj.rearmass) -- shape, transform, mass
	shipview.body:createFixture(shipobj.shape3, m3, shipobj.frontmass) -- shape, transform, mass
	shipview.body:createFixture(shipobj.shape4, m4, shipobj.frontmass) -- shape, transform, mass
--	shipview.body:createFixture(shipobj.shape, nil, 1024) -- shape, transform, mass
	--shipview.body:setType(r3d.Body.DYNAMIC_BODY)
	local mat = shipview.body:getMaterial() -- default: bounciness = 0.5, frictionCoefficient = 0.3, rollingResistance = 0
	mat.bounciness = 0
	mat.frictionCoefficient = 0.8
	mat.rollingResistance = 0.5 -- 0 = no resistance, 1 = max resistance
	shipview.body:setMaterial(mat)
	--shipview.body:enableGravity(true)
	
	return shipobj, shipview.body
end
